'setubx2.bas by df6nm 
'v2 19-02-05
'sets tp2 frequency, polarity for ublox lea-6t or neo-7/8t 
'fractional Hz frequencies by periodic advance of user delay#
'2a 19-12-13 replaced template.bin
'2b 19-12-15 timepulse2 or timepulse1

'usage: setubx2 frequency <tp>

'usage example 8270.0025 Hz:
':loop
'setubx2 >com6 8270.0025
'timeout 1
'goto loop

'$ lang: "qb"
deflng a-z

cmd$ = ltrim$(rtrim$(command$))
frequency#=val(cmd$)
tp=1
if instr(lcase$(cmd$),"tp")>0 then tp=0 'timepulse instead of timepulse2

if frequency# > 0 then flag=&heb 'rising edge
if frequency# < 0 then flag=&hab 'falling edge
if frequency# = 0 then flag=&hea 'no output
frequency# = abs(frequency#)

freq=int(frequency#+.5)
frac#=frequency#-freq
tt$=time$
tt$=right$("0"+tt$,8)
tod=val(mid$(tt$,1,2))*3600#+val(mid$(tt$,4,2))*60+val(mid$(tt$,7,2))
phase#=frac#*(tod+1)
phase#=phase#-int(phase#+.5)
delay#=phase#*1000000000#/frequency#
userdelay=delay#
'? freq;frac#;tt$;tod;phase#;userdelay

msg$=string$(40,0)
mid$(msg$,1,2)=mki$(&h62b5) 'B
mid$(msg$,3,2)=mki$(&h3106) 'CFG-TP5: 06 31
mid$(msg$,5,2)=mki$(32) 'message length

mid$(msg$,7,1)=chr$(tp) '1 for timepulse2, 0 for timepulse
mid$(msg$,7+1,1)=chr$(1) '(reserved)
mid$(msg$,7+4,2)=mki$(50) 'default antenna cable delay 50 ns
mid$(msg$,7+12,4)=mkl$(&h01) 'other freq/per when locked (1 Hz, not used)
mid$(msg$,7+16,4)=mkl$(&h80000000) 'duty cycle 50%
mid$(msg$,7+8,4)=mkl$(freq)  'Hz
mid$(msg$,7+24,4)=mkl$(userdelay) 'ns
mid$(msg$,7+28,4)=mkl$(flag)  '1p10 101a

cka=0:ckb=0
for n=3 to len(msg$)-2
 cka=(cka+asc(mid$(msg$,n,1))) and 255
 ckb=(ckb+cka) and 255
next n
mid$(msg$,len(msg$)-1,2)=chr$(cka)+chr$(ckb)

'for n=1 to len(msg$)
'? right$("0"+hex$(asc(mid$(msg$,n,1))),2);" ";
'next n

? msg$;
end
